/*
   -= X-Form - the bitmap tool =-  
                            
           /Mic, 2001      


 How to compile:
  
   lrc xform.rc
   lcc -O xform.c
   lcclnk -subsystem windows -s xform.obj xform.res

*/



#include "xformctl.h"
//#include "beeampee4.h"
#include "gifpcx.h"
#include "heapsort.h"
#include "vga_pal.h"
#include <math.h>


#define MY_ERROR(str)     MessageBox(NULL,str,\
                                  "D\'OH!",\
                                  MB_OK|MB_ICONEXCLAMATION)



CHAR szClassName[]="MyWindowClass";
HINSTANCE Instansen;
HDC hdc;		      	/* device context */


void *tempptr;
char szFilnamn[400];
static OPENFILENAME ofName;
static char szFileNameOnly[400];
HANDLE fileHandle;
unsigned long tID;

char bmpname[256],palname[256];
char slask[400], slask2[150];
int temp1,temp2;


rgb_type match_pal[256];
rgb_type current_pal[256];


char vscreen_bibuf[sizeof(BITMAPINFOHEADER) + 1024];
BITMAPINFO *vscreen_bi;
BITMAPINFOHEADER *vscreen_bih;
char *vscreen = NULL;
loaded_bitmap image,converted;


char BMPType[] = "Windows Bitmaps (*.bmp)\0*.BMP\0";
char RAWType[] = "RAW bitmap data (*.raw)\0*.RAW\0";
char PALType[] = "Palette files (*.pal)\0*.PAL\0";
char ALLType[] = "All files (*.*)\0*.*\0";

unsigned char stdcolors[] = {100,0,0,0,
                             220,0,0,0,
                             220,100,100,0,
                             0,100,0,0,
                             0,220,0,0,
                             100,220,100,0,
                             0,0,100,0,
                             0,0,220,0,
                             100,100,220,0,
                             255,255,255,0};


void update_PBar(int i1, int i2)
{
  ProgressBar_SetPos(pbar_progress,(i1*100)/i2);
}


void setExtension(char *szName, char *szExt)
{
  int l;
  int found = 0;

  l = 0;
  while (l<strlen(szName)) 
  {
    if (szName[l] == '.')  
    {
      found = 1;
      break;
    }
    l++; 
  }
  if (!found) 
    strcat(szName, szExt);
}


int get_openfilename(char *szBuf, char *szTitle, char *szFilter)
{
   ofName.lStructSize = sizeof(OPENFILENAME);
   ofName.hwndOwner = main_win;
   ofName.lpstrFilter = szFilter;
   ofName.nFilterIndex = 1;
   ofName.lpstrFile = szBuf;
   ofName.lpstrFileTitle = szFileNameOnly;
   ofName.nMaxFile = 399;
   ofName.lpstrInitialDir = NULL;
   ofName.lpstrTitle = szTitle;
   ofName.Flags = OFN_EXPLORER | OFN_OVERWRITEPROMPT;
   return (GetOpenFileName(&ofName));
}


int get_savefilename(char *szBuf, char *szTitle, char *szFilter)
{
   ofName.lStructSize = sizeof(OPENFILENAME);
   ofName.hwndOwner = main_win;
   ofName.lpstrFilter = szFilter;
   ofName.nFilterIndex = 1;
   ofName.lpstrFile = szBuf;
   ofName.lpstrFileTitle = szFileNameOnly;
   ofName.nMaxFile = 399;
   ofName.lpstrInitialDir = NULL;
   ofName.lpstrTitle = szTitle;
   ofName.Flags = OFN_EXPLORER | OFN_OVERWRITEPROMPT;
   return (GetSaveFileName(&ofName));
}



void set_windows_palette(char *src, char *dst)
{
int i;
int soffs, doffs;
  soffs = 0;  doffs = 0;
  for (i = 0; i < 256; i++) 
  {
    *(dst + doffs) = *(src + soffs + 2);
    *(dst + doffs + 1) = *(src + soffs + 1);
    *(dst + doffs + 2) = *(src + soffs);
    soffs += 3;
    doffs += 4;
  }
}



// Copy 'srcpal' to 'dstpal'
//
void copy_palette(rgb_type *dstpal, rgb_type *srcpal)
{
  memcpy((char *)dstpal, (char *)srcpal, 768);
}


// Set up the 'vscreen' bitmap
//
void create_palette_bitmap()
{
  int i,j,k,l;

  vscreen_bi = (BITMAPINFO *)&vscreen_bibuf;
  vscreen_bih = (BITMAPINFOHEADER *)&vscreen_bi->bmiHeader;
  vscreen_bih->biSize = sizeof(BITMAPINFOHEADER);
  vscreen_bih->biWidth = 256;
  vscreen_bih->biHeight = 48;
  vscreen_bih->biPlanes = 1;
  vscreen_bih->biBitCount = 8;
  vscreen_bih->biCompression = BI_RGB;
  vscreen_bih->biSizeImage = 0;
  vscreen_bih->biXPelsPerMeter = 0;
  vscreen_bih->biYPelsPerMeter = 0;
  vscreen_bih->biClrUsed = 0;
  vscreen_bih->biClrImportant = 0;

  vscreen = (char *)LocalAlloc(LPTR, 256*48);

  for (i=0; i<8; i++)
   for (j=0; j<6; j++)
    for (k=0; k<32; k++)
     for (l=0; l<8; l++)
      vscreen[( (i<<8)*6) + (j<<8) + (k<<3) + l] = ((7-i)<<5)+k;
}



// Generate a 332-ratio palette
//
void pal332(rgb_type *palptr)
{
  int i;
  rgb_type *col0 = palptr;

  for (i=0; i<256; i++)
  {
    palptr->r = ((((i>>5)&7)*255)/7) & 255;
    palptr->g = ((((i>>2)&7)*255)/7) & 255;
    palptr->b = (((i&3)*255)/3) & 255;
    palptr++;
  }
  palptr--;
  col0->r = 0;
  col0->g = 0;
  col0->b = 0;
  palptr->r = 255;
  palptr->g = 255;
  palptr->b = 255;
}


int fixedp_lum(int r1, int g1, int b1)
{
  return (r1 * 306) + (g1 * 601) + (b1 * 117);
}

int floatp_lum(int r1, int g1, int b1)
{
  return ((float)r1 * 0.299f) + ((float)g1 * 0.587f) + ((float)b1 * 0.114f);
}



void extract_rgb(unsigned int packed_col, rgb_type *col, int bitspp)
{
  if (bitspp==24)
  {
    col->r = (char)(packed_col);
    col->g = (char)(packed_col>>8);
    col->b = (char)(packed_col>>16);
  }
}

int find_similar_luminance_floatp(rgb_type *col, float maxdiff)
{
 int i;
 //float lum1,lum_diff;
 int r1,g1,b1;

  //lum1 = floatp_lum(col->r, col->g, col->b);

  for (i=0; i<256; i++)
  {
    //lum_diff = lum1 - floatp_lum(match_pal[i].r, match_pal[i].g, match_pal[i].b);
    //if (lum_diff < 0) lum_diff = -lum_diff;
    //if (lum_diff <= maxdiff)
    //  return 1;
    r1 = (int)col->r - (int)match_pal[i].r;    
    g1 = (int)col->g - (int)match_pal[i].g;    
    b1 = (int)col->b - (int)match_pal[i].b;    
    if (r1<0) r1 = -r1;
    if (g1<0) g1 = -g1;
    if (b1<0) b1 = -b1;
    if (floatp_lum(r1,g1,b1)<maxdiff)
      return 1;
  }

  return 0;
}

int find_similar_luminance_fixedp(rgb_type *col, int maxdiff)
{
 int i,lum1,lum_diff;
 
  lum1 = fixedp_lum(col->r, col->g, col->b);

  for (i=0; i<256; i++)
  {
    lum_diff = lum1 - fixedp_lum(match_pal[i].r,match_pal[i].g,match_pal[i].b);
    if (lum_diff < 0) lum_diff = -lum_diff;
    if (lum_diff <= maxdiff)
      return 1;
  }

  return 0;
}


int color_distance(int r1, int g1, int b1,  int r2, int g2, int b2)
{
  int rmean;
  int dr,dg,db;

  rmean = (r1 + r2) >> 1;
  dr = (r1 - r2);
  dr *= dr;
  dr = (dr * (512 + rmean)) >> 8;

  dg = (g1 - g2);
  dg = (dg * dg) << 2;

  db = (b1 - b2);
  db *= db;
  db = (db * (767 - rmean)) >> 8;

  return (dr + dg + db);
}

int find_similar_color(rgb_type *col, int mindist)
{
 int i;
 
  for (i=0; i<256; i++)
  {
    if (color_distance(col->r, col->g, col->b,
                       match_pal[i].r,match_pal[i].g,match_pal[i].b) < mindist)
      return 1;
  }

  return 0;
}




int linear_search(int key, int *list, int listlen)
{
 int *list2 = list;
 int i=0;

  while (i<listlen)
  {
    if (key == *(list2++))
      return i;
    i++;
  } 
  return -1;
}



int count_colors()
{
 int a,b,i,entries;
 int xx,yy;
 unsigned int col24;
 int temp;
 short col16;  
 unsigned char col8;
 int *colors;

 colors = LocalAlloc(LPTR, 1024);
 memset(colors,0,1024);

 entries = 0;

 for (xx=0; xx<image.xdim; xx++)
 { 
   for (yy=0; yy<image.ydim; yy++)
   { 
      if ((image.bpp==15)||(image.bpp==16))
      {
        col16 = *(image.lpbits + (yy*image.xdim<<1) + (xx<<1));
        col24 = col16;
      }
      else if (image.bpp==24)
      {
        b = ((yy*image.xdim) + xx);
        b = (b<<1)+b;
        col8 = image.lpbits[b+2];
        col24 = col8;
        col8 = image.lpbits[b+1];
        col24 = (col24<<8)+col8;
        col8 = image.lpbits[b];
        col24 = (col24<<8)+col8;
      }

       if (!entries)
       {
          colors[0] = col24;
          entries = 1;
       }
       else
       {
          temp = linear_search(col24, colors, entries);
          if (temp==-1)
          {
            if (entries==256) { LocalFree(colors); return -1; }
            colors[entries] = col24;
            entries++;
          }
       }
    }
    update_PBar(xx,image.xdim);
  }

  for (i=0; i<256; i++)
    extract_rgb(colors[i], &match_pal[i], image.bpp);

  LocalFree(colors);       
  return entries;
}




int linear_search_spec(int key, Heap *list, int listlen)
{
 int i=0;

  while (i<listlen)
  {
    if (key == list->data[i].id)
      return i;
    i++;
  } 
  return -1;
}



void generate_opt_palette()
{
 int bw,bh;
 int i,j,x,y;
 int xx,yy;
 int a,b,c,d;
 int picks,entries;
 unsigned char col8;
 short col16;
 unsigned int col24;
 rgb_type col;
 double d1;
 Heap colheap,candidates;
 static char foobar[16];


  if (count_colors()!=-1)
    return;


  picks = 1;

  /* Divide the image into blocks, based on the numbers of colors wanted */
  d1 = sqrt(255.0);
  d = (int)d1;
  bw = (int)((double)image.xdim/d1);
  bh = (int)((double)image.ydim/d1);
  if (!bw) bw = 1;
  if (!bh) bh = 1;

  memset(&match_pal[0].r,0,768);

  /* Create a heap to hold the colors */
  CreateHeap(&colheap, bw*bh);
  CreateHeap(&candidates, (d*d<<1)+10);
  memcpy(((int *)candidates.data)+(d*d<<1),&stdcolors,40);

  for (i=0; i<d; i++)
  {
    yy = i*bh;
    for (j=0; j<d; j++)
    {
      xx = j*bw;
      memset(colheap.data, 0, colheap.size<<3);
      entries = 0;

      for (y=0; y<bh; y++)
      {
      for (x=0; x<bw; x++)
      {

        if ((image.bpp==15)||(image.bpp==16))
        {
          col16 = *(image.lpbits + ((y+yy)*image.xdim<<1) + ((x+xx)<<1));
          col24 = col16;
        }
        else if (image.bpp==24)
        {
          b = (((y+yy)*image.xdim) + (x+xx));
          b = (b<<1)+b;
          col8 = image.lpbits[b];
          col24 = col8;
          col8 = image.lpbits[b+1];
          col24 = (col24<<8)+col8;
          col8 = image.lpbits[b+2];
          col24 = (col24<<8)+col8;
        }

        /* Look for the color.. */
        a = linear_search_spec(col24, &colheap, entries);
        if (a == -1)
        {
          /* This was a new color */
          colheap.data[entries].id = col24;
          colheap.data[entries].count = 1;
          entries++;
        }
        else
          /* Increase the count (frequency) of the color */
          colheap.data[a].count++;
      }
      }  


      /* Sort the heap (ascending order) */     
      HeapSort(&colheap, colheap.size-1);

      /* The colors with the highest counts will now be at the end of the heap */
      a = colheap.size-1;
      c = entries;
 
      /* Look for a color with a high frequency, and wich differs somewhat from all the
         other colors picked so far                                                      */
      while (c)
      {
         extract_rgb(colheap.data[a].id, &col, image.bpp);
         //if (find_similar_luminance_floatp(&col, 5.50f))
         if (find_similar_color(&col, 450))
         {
            /* A similar color is already in the palette */
            a--;
            if (a<0) break;
            c--;
         }
         else
         {
            /* Add the color to the palette */
            match_pal[picks] = col;
            picks++;
            if (picks==256)
            {
               DestroyHeap(&colheap);
               DestroyHeap(&candidates);
               return;
            }
            break;
         }
      }

      candidates.data[(((i*d)+j)<<1)].id = colheap.data[0].id;
      candidates.data[(((i*d)+j)<<1)+1].id = colheap.data[entries-1].id;
      update_PBar(picks, d*d);
    }
  }

  c = picks;

  DestroyHeap(&colheap);
  if (picks>=256)
  {
    DestroyHeap(&candidates);
    return;
  }

    /* Sort the candidate entries by luminance */
    for (i=0; i<(d*d<<1); i++)
    {
      extract_rgb(candidates.data[i].id, &col, image.bpp);
      candidates.data[i].count = fixedp_lum(col.r, col.g, col.b);
    }
    HeapSort(&candidates, candidates.size-1);

    /* The colors with the strongest luminances will now be at the end of the heap */
    a = candidates.size-1;

    /* Look for a color with a strong luminance, and wich differs somewhat from all the
       other colors picked so far                                                       */
    while (a)
    {
       extract_rgb(candidates.data[a].id, &col, image.bpp);
       //if (find_similar_luminance_floatp(&col, 2.10f))
       if (find_similar_color(&col, 200))
       {
          /* A similar color is already in the palette */
          a--;
          //if (a<0) break;
       }
       else
       {
          /* Add the color to the palette */
          match_pal[picks] = col;
          picks++;
          if (picks==256)
          {
             DestroyHeap(&candidates);
             return;
          }
          //break;
          a--;
       }
       update_PBar(picks, d*d);
    }

  //wsprintf(foobar,"%d | %d",c,picks);
  //SetWindowText(main_win,foobar);

  if (picks<256)
    for (i=0; i<(256-picks); i++)
    {
      extract_rgb(candidates.data[candidates.size-(i+1)].id, &col,image.bpp);
      match_pal[picks+i] = col;
      update_PBar(picks+i, d*d);
    }

  DestroyHeap(&candidates);
}

 


// Find the color in match_pal[] that is the closest match
// to {r1,g1,b1}.
//
int weighted_match(int r1, int g1, int b1)
{
  int i = 0;
  int rmean;
  int dr,dg,db;
  int min_diff = 12345678, match = 0;

  while (i<256)
  {
    rmean = (r1 + match_pal[i].r) >> 1;
    dr = (r1 - match_pal[i].r);
    dr *= dr;
    dr = (dr * (512 + rmean)) >> 8;

    dg = (g1 - match_pal[i].g);
    dg = (dg * dg) << 2;

    db = (b1 - match_pal[i].b);
    db *= db;
    db = (db * (767 - rmean)) >> 8;

    dr += (dg + db);

    if (dr==0)
      return i;
    else if (dr<min_diff)
    {
      min_diff = dr;
      match = i;
    }
    i++;
  }
  return match;
}


// Find two "best" matches, one slightly brighter and the other
// slightly darker. Pack the return value as (brighter<<8)+darker.
//
int weighted_dither_match(int r1, int g1, int b1)
{
  int i = 0;
  int rmean;
  int dr,dg,db;
  int min_diff1 = 12345678, min_diff2 = 12345678,
      brighter = 0, darker = 0;

  while (i<256)
  {
    rmean = (r1 + match_pal[i].r) >> 1;
    dr = (r1 - match_pal[i].r);
    dr *= dr;
    dr = (dr * (512 + rmean)) >> 8;

    dg = (g1 - match_pal[i].g);
    dg = (dg * dg) << 2;

    db = (b1 - match_pal[i].b);
    db *= db;
    db = (db * (767 - rmean)) >> 8;

    dr += (dg + db);

    if (dr==0)
      return (i<<8)+i;
    else if ((r1<match_pal[i].r)||(g1<match_pal[i].g)||
             (b1<match_pal[i].b))
    {
      if (dr<min_diff1)
      {
        min_diff1 = dr;
        brighter = i;
      }
    }
    else //if ((r1>match_pal[i].r)||(g1>match_pal[i].g)||
         //    (b1>match_pal[i].b))
    {
      if (dr<min_diff2)
      {
        min_diff2 = dr;
        darker = i;
      }
    }

    if (brighter < 0)
      brighter = darker;
    else if (darker < 0)
      darker = brighter;

    i++;
  }
  return (brighter<<8)+darker;
}
  


void convert_image()
{
 short col16;
 unsigned char c1,c2,c3;
 int r1,g1,b1;
 int i,j;
 int srcOffs,dstOffs;
 int temp;
 Heap colors;
 item new_entry; 
 int heap_entries,on_diagonale;
 
  srcOffs = 0;
  dstOffs = 0;

  CreateHeap(&colors,256);
  heap_entries = 0;
  on_diagonale = 0;

  for (i=0; i<image.ydim; i++)
  {
   for (j=0; j<image.xdim; j++)
   {
     if (image.bpp == 15)
     {
       col16 = *(image.lpbits+srcOffs);
       srcOffs += 2;
       b1 = (col16 & 0x1F)<<3;
       g1 = (col16 & 0x3E0)>>2;
       r1 = (col16 & 0x7C00)>>7;
       *(converted.lpbits+dstOffs) = (char)weighted_match(r1,g1,b1);
     }
     else if (image.bpp == 16)
     {
       col16 = *(image.lpbits+srcOffs);
       srcOffs += 2;
       b1 = (col16 & 0x1F)<<3;
       g1 = (col16 & 0x7E0)>>3;
       r1 = (col16 & 0xF800)>>8;
       *(converted.lpbits+dstOffs) = (char)weighted_match(r1,g1,b1);
     }
     else if (image.bpp == 24)
     {
       c3 = *(image.lpbits+(srcOffs++));
       c2 = *(image.lpbits+(srcOffs++));
       c1 = *(image.lpbits+(srcOffs++));
       r1 = c3;
       r1 = (r1<<8)+c2;
       r1 = (r1<<8)+c1;
       temp = OrderedLookup(r1, &colors, heap_entries);
       if (temp==-1)
       {
         c1 = (char)weighted_match(c1, c2, c3);
         converted.lpbits[dstOffs] = c1;
         if (heap_entries<256)
         {
           new_entry.id = r1;
           new_entry.count = c1;
           OrderedInsert(&new_entry, &colors, heap_entries);
           heap_entries++;
         }
       }
       else
         converted.lpbits[dstOffs] = (char)colors.data[temp].count;
     }
     else
     {
       /* Assume 8-bit */
       c1 = image.lpbits[srcOffs++];
       r1 = image.palette[c1].r;
       g1 = image.palette[c1].g;
       b1 = image.palette[c1].b;
       *(converted.lpbits+dstOffs) = (char)weighted_match(r1,g1,b1);
     }

     dstOffs++;
   }
   on_diagonale++;
   if (on_diagonale>=image.xdim) on_diagonale = 0;
   update_PBar(i,image.ydim);
  }

  DestroyHeap(&colors);
}



void dither_image()
{
 short col16;
 unsigned char c1,c2,c3;
 int r1,g1,b1;
 int i,j;
 int srcOffs,dstOffs;
 int temp;
 Heap colors;
 item new_entry; 
 int heap_entries;

  srcOffs = 0;
  dstOffs = 0;

  CreateHeap(&colors,256);
  heap_entries = 0;


  for (i=0; i<image.ydim; i++)
  {
   for (j=0; j<image.xdim; j++)
   {
     if (image.bpp == 15)
     {
       col16 = *(image.lpbits+srcOffs);
       srcOffs += 2;
       b1 = (col16 & 0x1F)<<3;
       g1 = (col16 & 0x3E0)>>2;
       r1 = (col16 & 0x7C00)>>7;
       r1 = weighted_dither_match(r1, g1, b1);
     }
     else if (image.bpp == 16)
     {
       col16 = *(image.lpbits+srcOffs);
       srcOffs += 2;
       b1 = (col16 & 0x1F)<<3;
       g1 = (col16 & 0x7E0)>>3;
       r1 = (col16 & 0xF800)>>8;
       r1 = weighted_dither_match(r1, g1, b1);
     }
     else if (image.bpp == 24)
     {
       c3 = *(image.lpbits+(srcOffs++));
       c2 = *(image.lpbits+(srcOffs++));
       c1 = *(image.lpbits+(srcOffs++));
       //r1 = weighted_dither_match(c1, c2, c3);
       g1 = c3;
       g1 = (g1<<8)+c2;
       g1 = (g1<<8)+c1;
       temp = OrderedLookup(g1, &colors, heap_entries);
       if (temp==-1)
       {
         r1 = weighted_dither_match(c1, c2, c3);
         if (heap_entries<256)
         {
           new_entry.id = g1;
           new_entry.count = r1;
           OrderedInsert(&new_entry, &colors, heap_entries);
           heap_entries++;
         }
       }
       else
         r1 = colors.data[temp].count;

     }
     else
     {
       /* Assume 8-bit */
       c1 = image.lpbits[srcOffs++];
       r1 = image.palette[c1].r;
       g1 = image.palette[c1].g;
       b1 = image.palette[c1].b;
       r1 = weighted_dither_match(r1, g1, b1);
     }

     if (!(i & 1))
       if (!(j & 1))
         c1 = (char)r1;
       else
         c1 = (char)(r1 >> 8);
     else
       if (j & 1)
         c1 = (char)r1;
       else
         c1 = (char)(r1 >> 8);

     *(converted.lpbits+(dstOffs++)) = c1;
   }
   update_PBar(i,image.ydim);
  }

  DestroyHeap(&colors);
}



void make_image_8bit()
{
 int wichpal;

  if (image.lpbits == NULL)
  {
    converted.errorcode = 1;
    return;
  }


  converted.lpbits = LocalAlloc(LPTR, image.xdim*image.ydim);
  converted.xdim = image.xdim;
  converted.ydim = image.ydim;
  converted.bpp = 8;
  converted.errorcode = 0;

  wichpal = CB_getIndex(cmb_palette);
  if (wichpal==0)
  {
    copy_palette(&match_pal[0], &current_pal[0]);
    copy_palette(&converted.palette[0], &current_pal[0]);
  }
  else if (wichpal==1)
  {
    copy_palette(&match_pal[0], (rgb_type *)&VGA_PALETTE[0]);
    copy_palette(&converted.palette[0], (rgb_type *)&VGA_PALETTE[0]);
  }
  else if (wichpal==2)
  {
    pal332(&match_pal[0]);
    copy_palette(&converted.palette[0], &match_pal[0]);
  }
  else if (wichpal==3)
  {
    ProgressBar_SetPos(pbar_progress, 1);
    SetWindowText(ltxt_progress,"Generating palette");
    generate_opt_palette();
    copy_palette(&converted.palette[0], &match_pal[0]);
  }

  ProgressBar_SetPos(pbar_progress, 1);
  SetWindowText(ltxt_progress,"Converting image");
  if (isChecked(chk_dither))
    dither_image();
  else
    convert_image();
}



  



/* This thread takes care of converting images to 8-bit color */

unsigned long CALLBACK convert_thread(char *cp)
{
   EnableWindow(btn_load, FALSE);
   EnableWindow(btn_convert, FALSE);
   EnableWindow(btn_quit, FALSE);
   EnableMenuItem(m_image, IDM_IMAGE_LOAD, MF_GRAYED);
   EnableMenuItem(m_image, IDM_IMAGE_CONVERT, MF_GRAYED);
   EnableMenuItem(m_image, IDM_IMAGE_QUIT, MF_GRAYED);

   if (isChecked(chk_invert))
     ConfigBMP(BMP_INVERT,BMP_INVERT);

   temp1 = CB_getIndex(cmb_format);
    if (temp1 == 0)
    {
      temp2 = get_savefilename(bmpname, "Save as..", BMPType);
      setExtension(bmpname, ".bmp");
    }
    else if (temp1 == 1)
    {
      temp2 = get_savefilename(bmpname, "Save as..", RAWType);
      setExtension(bmpname, ".raw");
      ConfigBMP(BMP_FLIP, BMP_DONT_FLIP);
      ConfigBMP(BMP_HEADER, BMP_NO_HEADER);
      ConfigBMP(BMP_PALETTE, BMP_NO_PALETTE);
      ConfigBMP(BMP_ALIGN, BMP_DONT_ALIGN);
    }

    ShowWindow(progress_win,SW_SHOW);

    if (temp2)
    {
       temp2 = CB_getIndex(cmb_colors);
       if (temp2 == 0)
       { 
         ProgressBar_SetPos(pbar_progress, 1);
         SetWindowText(ltxt_progress," ");
         make_image_8bit();
         if (converted.errorcode)
           MY_ERROR("Unable to convert image.");
         else
         {
           ProgressBar_SetPos(pbar_progress, 1);
           SetWindowText(ltxt_progress,"Saving image");
           if (SaveBMP(bmpname, &converted, &converted))
             MY_ERROR("Error while saving image.");
           LocalFree(converted.lpbits);
           ProgressBar_SetPos(pbar_progress, 100);
         }
       }
       else if (temp2 == 1)
       {
         converted.lpbits = image.lpbits;
         converted.xdim = image.xdim;
         converted.ydim = image.ydim;
         converted.bpp = 15;
         converted.errorcode = 0;
         if (SaveBMP(bmpname, &image, &converted))
           MY_ERROR("Error while saving image.");
       } 

    }
    if (temp1 == 1)
    {
      ConfigBMP(BMP_FLIP, BMP_FLIP);
      ConfigBMP(BMP_HEADER, BMP_HEADER);
      ConfigBMP(BMP_PALETTE, BMP_PALETTE);
      ConfigBMP(BMP_ALIGN, BMP_ALIGN);
    }

  ShowWindow(progress_win,SW_HIDE);
  EnableWindow(btn_load, TRUE);
  EnableWindow(btn_convert, TRUE);
  EnableWindow(btn_quit, TRUE);
  EnableMenuItem(m_image, IDM_IMAGE_LOAD, MF_ENABLED);
  EnableMenuItem(m_image, IDM_IMAGE_CONVERT, MF_ENABLED);
  EnableMenuItem(m_image, IDM_IMAGE_QUIT, MF_ENABLED);

  ConfigBMP(BMP_INVERT,BMP_DONT_INVERT);

  return 0;
}


void load_AGB_palette()
{
 static unsigned short agb_pal[256];
 int i;

  ReadFile(fileHandle, &agb_pal[0], 512, &temp1, NULL);
  for (i=0; i<256; i++)
  {
    current_pal[i].r = (agb_pal[i] & 31)<<3;
    current_pal[i].g = (agb_pal[i] & 992)>>2;
    current_pal[i].b = (agb_pal[i] & 31744)>>7;
  }
  CloseHandle(fileHandle);
}


void load_BMP_palette()
{
  static unsigned char bmp_pal[1024];
  short bmpbitcount;
  int i;

  SetFilePointer(fileHandle, 28, NULL, FILE_BEGIN);
  ReadFile(fileHandle, &bmpbitcount, 2, &temp1, NULL);
  if (bmpbitcount!=8)
  {
    CloseHandle(fileHandle);
    MY_ERROR("This bitmap does not have a palette.");
    return;
  }

  SetFilePointer(fileHandle, 54, NULL, FILE_BEGIN);
  ReadFile(fileHandle, &bmp_pal[0], 1024, &temp1, NULL);

  for (i=0; i<256; i++)
  {
    current_pal[i].b = bmp_pal[(i<<2)];
    current_pal[i].g = bmp_pal[(i<<2)+1];
    current_pal[i].r = bmp_pal[(i<<2)+2];
  }
  CloseHandle(fileHandle);
}


void load_PC_palette()
{
  ReadFile(fileHandle, &current_pal[0].r, 768, &temp1, NULL);
  CloseHandle(fileHandle);
}


void load_palette()
{
  int i,fs;

  for (i=0; i<30; i++) slask2[i] = BMPType[i];
  for (i=0; i<29; i++) slask2[30+i] = PALType[i];

  if (get_openfilename(palname, "Load palette", slask2))
  {
    setExtension(palname, ".pal");
    fileHandle = CreateFile(palname, GENERIC_READ, 0, NULL, OPEN_EXISTING,
                 FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN, NULL);
    if (fileHandle == INVALID_HANDLE_VALUE)
    {
      MY_ERROR("Unable to create file.");
      return;
    }
    fs = GetFileSize(fileHandle, NULL);
    if (fs == 512)
      load_AGB_palette();
    else if (fs == 768)
      load_PC_palette();
    else if (fs > 1078)
      load_BMP_palette();
    else
    {
      CloseHandle(fileHandle);
      MY_ERROR("Unknown palette format.");
      return;
    }
  }
}




/* Save current_pal[] in AGB format (2 bytes/color) */

void save_AGB_palette()
{
  static unsigned short agb_pal[256];
  int i;

  if (get_savefilename(palname, "Save palette (AGB format)", PALType))
  {
    setExtension(palname, ".pal");
    fileHandle = CreateFile(palname, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS,
                 FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN, NULL);
    if (fileHandle == INVALID_HANDLE_VALUE)
    {
      MY_ERROR("Unable to create file.");
    }

    for (i = 0; i<256; i++)
      agb_pal[i] = ((current_pal[i].r >> 3)+
                    (((int)current_pal[i].g & 0xF8) << 2)+
                    (((int)current_pal[i].b & 0xF8) << 7));

    WriteFile(fileHandle, &agb_pal[0], 512, &temp1, NULL);
    CloseHandle(fileHandle);
  }
}



/* Save current_pal[] in "PC" format (3 bytes/color) */

void save_PC_palette()
{
  if (get_savefilename(palname, "Save palette (PC format)", PALType))
  {
    setExtension(palname, ".pal");
    fileHandle = CreateFile(palname, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS,
                 FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN, NULL);
    if (fileHandle == INVALID_HANDLE_VALUE)
    {
      MY_ERROR("Unable to create file.");
    }

    WriteFile(fileHandle, &current_pal[0].r, 768, &temp1, NULL);
    CloseHandle(fileHandle);
  }
}



/* Take care of messages sent by menu items */

VOID process_menu_message(HWND hwnd, UINT command)
{

 switch(command)
 {

  case IDM_IMAGE_LOAD:
    /* Load a bitmap (DIB) */
    if (get_openfilename(bmpname, "Load bitmap", BMPType))
    {
      if (image.lpbits!=NULL) LocalFree(image.lpbits);
      LoadBMP(bmpname, &image);
      if (image.errorcode!=0)
      {
        MY_ERROR("Unable to load image.");
        image.lpbits = NULL;
      }
      else
      {
        wsprintf(slask2, "%s (%dx%d, %dbit)",
                 szFileNameOnly, image.xdim, image.ydim, image.bpp);
        SetWindowText(main_win, slask2);
      } 
    }
    break;


  case IDM_IMAGE_CONVERT:
    /* Create a new thread with normal priority and start it immediately */
    CreateThread(0, 4096, convert_thread, 0, 0, &tID);
    break;


  case IDM_IMAGE_QUIT:
   PostQuitMessage(0);
   break;

  case IDM_PAL_LOAD:
   load_palette();
   break;

  case IDM_PAL_SAVE_AGB:
   save_AGB_palette();
   break;
  case IDM_PAL_SAVE_PC:
   save_PC_palette();
   break;

  case IDM_PAL_VIEW:
   set_windows_palette((char *)(&current_pal[0].r), &vscreen_bibuf[40]);
   ShowWindow(palette_win,SW_SHOW);
   break;


  case IDM_HELP_ABOUT:
   MessageBox(NULL,"X-Form\n/Mic, 2001\n\nThanks to Christopher Street for the dithering algorithm",
                   "Why are you reading this anyway..?",
              MB_OK|MB_ICONINFORMATION);
   break;
  default:
   DrawMenuBar(hwnd);
 }
}
 



/* Take care of messages sent by controls (buttons, listboxes etc.) */

VOID process_control_message(HWND hwnd, UINT wParam, UINT lParam)
{
  switch (HIWORD(wParam))
  {
    /* BN_CLICKED is sent whenever a button (pushbtn, checkbox etc) is clicked */
    case BN_CLICKED:
      if ((HWND)lParam == btn_quit)
        PostQuitMessage(0);
      else if ((HWND)lParam == btn_load)
        SendMessage(main_win, WM_COMMAND, IDM_IMAGE_LOAD, 0);
      else if ((HWND)lParam == btn_convert)
        SendMessage(main_win, WM_COMMAND, IDM_IMAGE_CONVERT, 0);
      break;

    default:
      break;
  }
}



LRESULT CALLBACK WndProc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam)
{
RECT pal_rect;

  switch(message) {
   case WM_CREATE:
     break;

   case WM_SHOWWINDOW:
     if (hwnd == main_win)
     {
       /* Get rid of the ugly boldfaced font */
       defaultFontID = (UINT)GetStockObject(ANSI_VAR_FONT);

       create_controls();
       create_palette_bitmap();
       pal332(&current_pal[0]);
     }
     else if (hwnd == palette_win)
       SendMessage(palette_win, WM_SIZE, 0, 0);
     break;


   case WM_COMMAND:
     if (hwnd == main_win)
     {
       if (lParam == 0)
         process_menu_message(hwnd, LOWORD(wParam));
       else
         process_control_message(hwnd, wParam, lParam); 
     }
     break;

   case WM_SIZE:
     if (hwnd == palette_win)
     {
       if (vscreen != NULL)
       {
         hdc = GetDC(palette_win);
         GetWindowRect(palette_win, &pal_rect);
         StretchDIBits(hdc, 0,0, pal_rect.right+1-pal_rect.left, pal_rect.bottom+1-pal_rect.top,
                       0,0, 256,48,
                       vscreen, vscreen_bi, DIB_RGB_COLORS, SRCCOPY);
         ReleaseDC(palette_win, hdc);
       } 
     }
     break;

   case WM_CLOSE:
     if (hwnd == palette_win)
       ShowWindow(palette_win,SW_HIDE);
     break;

   case WM_DESTROY:
     if (hwnd == main_win)
       PostQuitMessage(0);
     break;

   default:
    return DefWindowProc(hwnd,message,wParam,lParam);
  }
  return 0;
}




INT WINAPI WinMain(HINSTANCE hThisInstance,HINSTANCE hPrevInstance,
                   LPSTR lpszArgument,INT nWndStyle)
{
 MSG userMsg;
 WNDCLASSEX wndClass;


  ConfigBMP(BMP_FLIP, BMP_FLIP);
  ConfigBMP(BMP_HEADER, BMP_HEADER);
  ConfigBMP(BMP_PALETTE, BMP_PALETTE);
  ConfigBMP(BMP_ALIGN, BMP_ALIGN);

  image.lpbits = NULL;


  Instansen = hThisInstance;

  wndClass.hInstance	= hThisInstance;
  wndClass.lpszClassName= szClassName;
  wndClass.lpfnWndProc	= WndProc;
  wndClass.style	= CS_OWNDC|CS_HREDRAW|CS_VREDRAW;
  wndClass.cbSize	= sizeof(WNDCLASSEX);
  wndClass.hIcon	= LoadIcon(hThisInstance,MAKEINTRESOURCE(IDI_IKONEN));
  wndClass.hIconSm	= LoadIcon(hThisInstance,MAKEINTRESOURCE(IDI_IKONEN));
  wndClass.hCursor	= LoadCursor(NULL,IDC_ARROW);
  wndClass.lpszMenuName	= NULL;
  wndClass.cbClsExtra	= 0;
  wndClass.cbWndExtra	= 0;
  wndClass.hbrBackground= (HBRUSH)(COLOR_BTNFACE+1);
  if (!RegisterClassEx(&wndClass)) return 0;

  main_win = CreateWindowEx(NULL,szClassName,"X-Form",WS_DLGFRAME|WS_SYSMENU|WS_MINIMIZEBOX,
                      CW_USEDEFAULT,CW_USEDEFAULT,278,362,NULL,
                      NULL,hThisInstance,NULL);
  
  palette_win = CreateWindowEx(NULL,szClassName,"Current palette",WS_THICKFRAME|WS_OVERLAPPED|
                      WS_CAPTION|WS_SYSMENU|WS_MINIMIZEBOX,
                      CW_USEDEFAULT,CW_USEDEFAULT,264,90,NULL,
                      NULL,hThisInstance,NULL);

  progress_win = CreateWindowEx(NULL,szClassName,"Working",WS_DLGFRAME|WS_CAPTION,
                      CW_USEDEFAULT,CW_USEDEFAULT,200,100,main_win,
                      NULL,hThisInstance,NULL);


  ShowWindow(main_win,nWndStyle);

  while (GetMessage(&userMsg,NULL,0,0)) {
     TranslateMessage(&userMsg);
     DispatchMessage(&userMsg);
  }

  /* Free some resources and exit */
  if (image.lpbits!=NULL) LocalFree(image.lpbits);
  destroy_controls();
  LocalFree(vscreen);
  DestroyWindow(palette_win);
  DestroyWindow(progress_win);

  ExitProcess(0);
  return userMsg.wParam;
}
