#include <windows.h>
#include "ProgressBar.h"


/* menu-ID:s */
#define IDM_IMAGE_LOAD		110
#define IDM_IMAGE_CONVERT    	111
#define IDM_IMAGE_QUIT      	112

#define IDM_PAL_LOAD		120
#define IDM_PAL_SAVE		121
  #define IDM_PAL_SAVE_AGB	1210
  #define IDM_PAL_SAVE_PC	1211
#define IDM_PAL_VIEW		122

#define IDM_HELP_ABOUT		130
	
#define IDI_IKONEN		500


#define IDC_GRP_OUTPUT		201
#define IDC_LTXT_FORMAT		202
#define IDC_CMB_FORMAT		203
#define IDC_LTXT_COLORS		204
#define IDC_CMB_COLORS		205
#define IDC_LTXT_PALETTE	206
#define IDC_CMB_PALETTE		207
#define IDC_LTXT_MATCH		208
#define IDC_CMB_MATCH		209
#define IDC_CHK_DITHER		210
#define IDC_CHK_INVERT		211
#define IDC_CHK_SWAP		212
#define IDC_BTN_LOAD		213
#define IDC_BTN_CONVERT		214
#define IDC_BTN_QUIT		215
#define IDC_LTXT_PROGRESS	216
#define IDC_PBAR_PROGRESS	217


HWND main_win, palette_win, progress_win;		


HMENU m_main,			/* menues */
      m_image, m_pal, m_pal_save, m_help;


HWND grp_output,
     ltxt_format,cmb_format,
     ltxt_colors,cmb_colors,
     ltxt_palette,cmb_palette,
     ltxt_match,cmb_match,
     chk_dither, chk_invert, chk_swap,
     btn_load, btn_convert, btn_quit,
     ltxt_progress, pbar_progress;

UINT defaultFontID;
  


void CB_addItem(HWND hCmb, char *szItem)
{
  SendMessage(hCmb, CB_ADDSTRING, 0, (long int)szItem);
}

void CB_setIndex(HWND hCmb, int index)
{
  SendMessage(hCmb, CB_SETCURSEL, (long int)index, 0);
}

int CB_getIndex(HWND hCmb)
{
  return SendMessage(hCmb, CB_GETCURSEL, 0, 0);
}


int isChecked(HWND hCtl)
{
  return SendMessage(hCtl, BM_GETCHECK, 0, 0);
}



void create_controls()
{

  m_main = CreateMenu();
    m_image = CreatePopupMenu();
    m_pal = CreatePopupMenu();
      m_pal_save = CreatePopupMenu();
    m_help = CreatePopupMenu();
 
 AppendMenu(m_main, (MF_ENABLED | MF_POPUP), (UINT)m_image, "Image");
   AppendMenu(m_image,(MF_ENABLED | MF_STRING),IDM_IMAGE_LOAD,"Load..");
   AppendMenu(m_image,(MF_ENABLED | MF_STRING),IDM_IMAGE_CONVERT,"Convert");
   AppendMenu(m_image, MF_SEPARATOR, NULL, NULL);
   AppendMenu(m_image,(MF_ENABLED | MF_STRING),IDM_IMAGE_QUIT,"Quit");

 AppendMenu(m_main, (MF_ENABLED | MF_POPUP), (UINT)m_pal, "Palette");
   AppendMenu(m_pal,(MF_ENABLED | MF_STRING),IDM_PAL_LOAD,"Load..");
   AppendMenu(m_pal,(MF_ENABLED | MF_POPUP),(UINT)m_pal_save,"Save");
     AppendMenu(m_pal_save,(MF_ENABLED | MF_STRING),IDM_PAL_SAVE_AGB,"AGB format..");
     AppendMenu(m_pal_save,(MF_ENABLED | MF_STRING),IDM_PAL_SAVE_PC,"PC format..");
   AppendMenu(m_pal, MF_SEPARATOR, NULL, NULL);
   AppendMenu(m_pal,(MF_ENABLED | MF_STRING),IDM_PAL_VIEW,"View");

 AppendMenu(m_main, (MF_ENABLED | MF_POPUP), (UINT)m_help, "Help");
   AppendMenu(m_help,(MF_ENABLED | MF_STRING),IDM_HELP_ABOUT,"About..");



  /* Create a groupbox */

  grp_output = CreateWindowEx(
           0,
           "button",
           "Output",
           BS_GROUPBOX|WS_CHILD|WS_VISIBLE,
           8, 4, 258, 248,
           main_win,
           (HMENU)IDC_GRP_OUTPUT,
           (HINSTANCE)GetWindowLong(main_win,GWL_HINSTANCE),
           NULL);
  SendMessage(grp_output, WM_SETFONT, defaultFontID, -1);


  ltxt_format = CreateWindowEx(
           0,
           "Static",
           "Format:",
           WS_CHILD|WS_VISIBLE,
           16,20,48,20,
           main_win,
           (HMENU)IDC_LTXT_FORMAT,
           (HINSTANCE)GetWindowLong(main_win,GWL_HINSTANCE),
           NULL);
  SendMessage(ltxt_format, WM_SETFONT, defaultFontID, -1);

  ltxt_colors = CreateWindowEx(
           0,
           "Static",
           "Colors:",
           WS_CHILD|WS_VISIBLE,
           146,20,48,20,
           main_win,
           (HMENU)IDC_LTXT_COLORS,
           (HINSTANCE)GetWindowLong(main_win,GWL_HINSTANCE),
           NULL);
  SendMessage(ltxt_colors, WM_SETFONT, defaultFontID, -1);

  ltxt_palette = CreateWindowEx(
           0,
           "Static",
           "Palette:",
           WS_CHILD|WS_VISIBLE,
           16,124,48,20,
           main_win,
           (HMENU)IDC_LTXT_PALETTE,
           (HINSTANCE)GetWindowLong(main_win,GWL_HINSTANCE),
           NULL);
  SendMessage(ltxt_palette, WM_SETFONT, defaultFontID, -1);

  ltxt_match = CreateWindowEx(
           0,
           "Static",
           "Color matching:",
           WS_CHILD|WS_VISIBLE,
           146,124,110,20,
           main_win,
           (HMENU)IDC_LTXT_MATCH,
           (HINSTANCE)GetWindowLong(main_win,GWL_HINSTANCE),
           NULL);
  SendMessage(ltxt_match, WM_SETFONT, defaultFontID, -1);




  cmb_format = CreateWindowEx(
           WS_EX_CLIENTEDGE,
           "combobox",
           "",
           WS_CHILD|WS_VISIBLE|WS_VSCROLL|
           CBS_DISABLENOSCROLL|CBS_DROPDOWN|CBS_HASSTRINGS|
           WS_TABSTOP,
           16,44,115,120,
           main_win,
           (HMENU)IDC_CMB_FORMAT,
           (HINSTANCE)GetWindowLong(main_win,GWL_HINSTANCE),
           NULL);
  SendMessage(cmb_format, WM_SETFONT, defaultFontID, -1);
  CB_addItem(cmb_format, "BMP");
  CB_addItem(cmb_format, "RAW");
  CB_setIndex(cmb_format, 0);

  cmb_colors = CreateWindowEx(
           WS_EX_CLIENTEDGE,
           "combobox",
           "",
           WS_CHILD|WS_VISIBLE|WS_VSCROLL|
           CBS_DISABLENOSCROLL|CBS_DROPDOWN|CBS_HASSTRINGS|
           WS_TABSTOP,
           146,44,115,120,
           main_win,
           (HMENU)IDC_CMB_COLORS,
           (HINSTANCE)GetWindowLong(main_win,GWL_HINSTANCE),
           NULL);
  SendMessage(cmb_colors, WM_SETFONT, defaultFontID, -1);
  CB_addItem(cmb_colors, "256");
  CB_addItem(cmb_colors, "32768");
  CB_addItem(cmb_colors, "65536");
  CB_addItem(cmb_colors, "16777216");
  CB_setIndex(cmb_colors, 0);

  cmb_palette = CreateWindowEx(
           WS_EX_CLIENTEDGE,
           "combobox",
           "",
           WS_CHILD|WS_VISIBLE|WS_VSCROLL|
           CBS_DISABLENOSCROLL|CBS_DROPDOWN|CBS_HASSTRINGS|
           WS_TABSTOP,
           16,148,115,120,
           main_win,
           (HMENU)IDC_CMB_PALETTE,
           (HINSTANCE)GetWindowLong(main_win,GWL_HINSTANCE),
           NULL);
  SendMessage(cmb_palette, WM_SETFONT, defaultFontID, -1);
  CB_addItem(cmb_palette, "Current palette");
  CB_addItem(cmb_palette, "VGA default palette");
  CB_addItem(cmb_palette, "332-ratio palette");
  CB_addItem(cmb_palette, "Optimized palette");
  CB_setIndex(cmb_palette, 0);  

  cmb_match = CreateWindowEx(
           WS_EX_CLIENTEDGE,
           "combobox",
           "",
           WS_CHILD|WS_VISIBLE|WS_VSCROLL|
           CBS_DISABLENOSCROLL|CBS_DROPDOWN|CBS_HASSTRINGS|
           WS_TABSTOP,
           146,148,115,120,
           main_win,
           (HMENU)IDC_CMB_MATCH,
           (HINSTANCE)GetWindowLong(main_win,GWL_HINSTANCE),
           NULL);
  SendMessage(cmb_match, WM_SETFONT, defaultFontID, -1);
  CB_addItem(cmb_match, "Weighted match");
  CB_setIndex(cmb_match, 0);  



  /* Create some checkboxes */

  chk_dither = CreateWindowEx(
           0,
           "button",
           "Dither",
           BS_AUTOCHECKBOX|WS_CHILD|WS_VISIBLE|WS_TABSTOP,
           16,204,64,20,
           main_win,
           (HMENU)IDC_CHK_DITHER,
           (HINSTANCE)GetWindowLong(main_win,GWL_HINSTANCE),
           NULL);
  SendMessage(chk_dither, WM_SETFONT, defaultFontID, -1);

  chk_invert = CreateWindowEx(
           0,
           "button",
           "Invert colors",
           BS_AUTOCHECKBOX|WS_CHILD|WS_VISIBLE|WS_TABSTOP,
           16,226,90,20,
           main_win,
           (HMENU)IDC_CHK_INVERT,
           (HINSTANCE)GetWindowLong(main_win,GWL_HINSTANCE),
           NULL);
  SendMessage(chk_invert, WM_SETFONT, defaultFontID, -1);

  chk_swap = CreateWindowEx(
           0,
           "button",
           "RGB->BGR",
           BS_AUTOCHECKBOX|WS_CHILD|WS_VISIBLE|WS_TABSTOP,
           146,204,80,20,
           main_win,
           (HMENU)IDC_CHK_SWAP,
           (HINSTANCE)GetWindowLong(main_win,GWL_HINSTANCE),
           NULL);
  SendMessage(chk_swap, WM_SETFONT, defaultFontID, -1);


  /* Create some pushbuttons */
  
  btn_load = CreateWindowEx(
           0,
           "button",
           "Load",
           BS_PUSHBUTTON|WS_CHILD|WS_VISIBLE|WS_TABSTOP,
           8, 264, 56, 28,
           main_win,
           (HMENU)IDC_BTN_LOAD,
           (HINSTANCE)GetWindowLong(main_win,GWL_HINSTANCE),
           NULL);
  SendMessage(btn_load, WM_SETFONT, defaultFontID, -1);

  btn_convert = CreateWindowEx(
           0,
           "button",
           "Convert",
           BS_PUSHBUTTON|WS_CHILD|WS_VISIBLE|WS_TABSTOP,
           70, 264, 56, 28,
           main_win,
           (HMENU)IDC_BTN_CONVERT,
           (HINSTANCE)GetWindowLong(main_win,GWL_HINSTANCE),
           NULL);
  SendMessage(btn_convert, WM_SETFONT, defaultFontID, -1);

  btn_quit = CreateWindowEx(
           0,
           "button",
           "Quit",
           BS_PUSHBUTTON|WS_CHILD|WS_VISIBLE|WS_TABSTOP,
           208, 264, 56, 28,
           main_win,
           (HMENU)IDC_BTN_QUIT,
           (HINSTANCE)GetWindowLong(main_win,GWL_HINSTANCE),
           NULL);
  SendMessage(btn_quit, WM_SETFONT, defaultFontID, -1);


  pbar_progress =
    ProgressBar_Create(progress_win, (HINSTANCE)GetWindowLong(progress_win,GWL_HINSTANCE),
                       (HMENU)IDC_PBAR_PROGRESS, 5, 44, 180, 18);
                 
 ltxt_progress = CreateWindowEx(
           0,
           "Static",
           "Generating palette",
           WS_CHILD|WS_VISIBLE,
           8,20,150,16,
           progress_win,
           (HMENU)IDC_LTXT_PROGRESS,
           (HINSTANCE)GetWindowLong(progress_win,GWL_HINSTANCE),
           NULL);
  SendMessage(ltxt_progress, WM_SETFONT, defaultFontID, -1);



  SetMenu(main_win, m_main);
  InitCommonControls();
  ProgressBar_SetRange(pbar_progress,1,100);
}





void destroy_controls()
{
  DestroyWindow(grp_output);

  DestroyWindow(ltxt_format);
  DestroyWindow(ltxt_colors);
  DestroyWindow(ltxt_palette);
  DestroyWindow(ltxt_match);

  DestroyWindow(cmb_format);
  DestroyWindow(cmb_colors);
  DestroyWindow(cmb_palette);
  DestroyWindow(cmb_match);

  DestroyWindow(chk_dither);
  DestroyWindow(chk_invert);
  DestroyWindow(chk_swap);

  DestroyWindow(btn_load);
  DestroyWindow(btn_convert);
  DestroyWindow(btn_quit);

  DestroyWindow(ltxt_progress);
  DestroyWindow(pbar_progress);
}

